import { ApolloClientOptions, ApolloClient, DocumentNode } from '@apollo/client/core';
import { NormalizedCacheObject } from '@apollo/client/cache';
import { IMockSubscription } from './mockSubscription';
export declare type RequestHandler<TData = any, TVariables = any> = (variables: TVariables) => Promise<RequestHandlerResponse<TData>> | IMockSubscription<TData>;
export declare type RequestHandlerResponse<T> = {
    data: T;
} | {
    errors: any[];
};
export declare type MockApolloClient = ApolloClient<NormalizedCacheObject> & {
    setRequestHandler: (query: DocumentNode, handler: RequestHandler) => void;
};
export declare type MockApolloClientOptions = Partial<Omit<ApolloClientOptions<NormalizedCacheObject>, 'link'>> | undefined;
export declare const createMockClient: (options?: MockApolloClientOptions) => MockApolloClient;
